datablock ParticleData(godgun1)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0;
	constantAcceleration = -2.0;
	spinRandomMin        = -300;
	spinRandomMax        = 300;
	lifetimeMS           = 3000;
	lifetimeVarianceMS   = 250;
	textureName          = "./god.png";
	colors[0]            = "1 0 0 0";
	colors[1]            = "1 1 1 1";
	colors[2]            = "1 0 0 0.5";
	colors[3]            = "1 0 0 0";
	sizes[0]             = 0.1;
	sizes[1]             = 1.5;
	sizes[2]             = 0.7;
	sizes[3]             = 0.2;
	times[0]             = 0;
	times[1]             = 0.4;
	times[2]             = 0.8;
	times[3]             = 1;
};

datablock ParticleEmitterData(godgun1Emitter)
{
	ejectionPeriodMS = 200;
	periodVarianceMS = 100;
	ejectionVelocity = 5;
	velocityVariance = 0;
	ejectionOffset   = 0.4;
	thetaMin         = 5;
	thetaMax         = 25;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance  = false;
	particles        = "godgun1";

	uiName = "Godgun Ambient";
};

datablock ParticleData(godgunExplosionParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   spinRandomMin	= -500;
   spinRandomMax	= 500;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 500;
   textureName          = "./god.png";
   colors[0]		= "1 1 1 1";
   colors[1]		= "1 0 0 0";
   sizes[0]		= 2;
   sizes[1]		= 0.5;
};

datablock ParticleEmitterData(godgunExplosionEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GodgunExplosionParticle";

   uiName = "Godgun Explosion 1";
};

datablock ParticleData(godgunExplosionParticle2)
{
   dragCoefficient      = 1;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0;
   constantAcceleration = 0;
   spinRandomMin	= 0.1;
   spinRandomMax	= 1;
   lifetimeMS           = 3000;
   lifetimeVarianceMS   = 0;
   textureName          = "./god.png";
   colors[0]		= "1 1 1 1";
   colors[1]		= "1 0 0 0";
   sizes[0]		= 5;
   sizes[1]		= 3;
};

datablock ParticleEmitterData(godgunExplosionEmitter2)
{
   ejectionPeriodMS = 500;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "godgunExplosionParticle2";

   uiName = "Godgun Explosion 2";
};

datablock ExplosionData(godgunExplosion)
{
   lifeTimeMS = 650;

   soundProfile = vehicleExplosionSound;

   particleEmitter = godgunExplosionEmitter;
   particleDensity = 75;
   particleRadius = 0.1;

   emitter[0] = godgunExplosionEmitter2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "200 200 200";
   camShakeAmp = "5 5 5";
   camShakeDuration = 0.1;
   camShakeRadius = 25;

   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "1 1 1 1";
   lightEndColor = "1 0 0 1";

   uiName = "PWNed";
};

datablock ProjectileData(godgunprojectile)
{
   projectileShapeName = "Add-ons/weapon_gun/bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = godgunExplosion;
   particleEmitter     = "godgunExplosionEmitter";

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "GodGun Bullet";
};

datablock ItemData(godgunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "Add-ons/weapon_gun/pistol.dts";
	mass = 2;
	density = 1;
	elasticity = 0.1;
	friction = 0.9;
	emap = true;

	uiName = "god gun";
	iconName = "Add-ons/weapon_gun/icon_gun.png";
	doColorShift = true;
	colorShiftColor = "0 5 5 1";

	image = godgunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(godgunImage)
{
   shapeFile = "Add-ons/weapon_gun/pistol.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";
   className = "WeaponImage";
   item = GunItem;
   ammo = " ";
   projectile = godgunProjectile;
   projectileType = Projectile;
   showBricks = true;

   melee = false;
   doRetraction = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = godgunItem.ColorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = playerMountSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]			= Godgun1Emitter;
	stateEmitterTime[1]		= 600;
	stateEmitterNode[1]		= fire;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";
};

function GodgunImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function GodgunImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}